﻿namespace WorkerRole1

open System
open System.Collections.Generic
open System.Diagnostics
open System.Linq
open System.Net
open System.Threading
open Microsoft.WindowsAzure
open Microsoft.WindowsAzure.Diagnostics
open Microsoft.WindowsAzure.ServiceRuntime
open Microsoft.Owin.Hosting

type WorkerRole() =
    inherit RoleEntryPoint() 

    // This is a sample worker implementation. Replace with your logic.
    let mutable webApp = Unchecked.defaultof<IDisposable>
    let log message (kind : string) = Trace.TraceInformation(message, kind)

    override wr.Run() =

        log "WorkerRole1 entry point called" "Information"
        while(true) do 
            Thread.Sleep(10000)
            log "Working" "Information"

    override wr.OnStart() = 

        // Set the maximum number of concurrent connections 
        ServicePointManager.DefaultConnectionLimit <- 12
       
        // For information on handling configuration changes
        // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.

        let endpoint = RoleEnvironment.CurrentRoleInstance.InstanceEndpoints.["Endpoint1"]
        let baseUri = sprintf "%s://%A" endpoint.Protocol endpoint.IPEndpoint
        log ("Starting OWIN at " + baseUri) "Information"
        let options = StartOptions()
        options.Urls.Add(baseUri)
        webApp <- WebApp.Start<MyStartUp.MyWebStartup>(options)
        
        //MyLogics.demoData |> MyLogics.AddToBlob


        base.OnStart()

    override wr.OnStop() =
        if webApp <> Unchecked.defaultof<IDisposable> then
            webApp.Dispose()
        base.OnStop()
